// Code to launch a simple dialog for getting a string input
//  used in NetTacToe
// Author : Jimb Esser (wasteland@writeme.com)
// Date : 1-28-1
// Version : 1.0


#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <cdx.h>
#include <cdxscreen.h>
#include "resource.h"



int iDepth=0; // Counts how many times EnterGDI has been called without an ExitGDI
 // Called when entering/exiting a dialog/gdi function
void EnterGDI(CDXScreen * Screen)
{
	if (iDepth==0) {
		Screen->GetDD()->FlipToGDISurface();
	}
	iDepth++;
}

void ExitGDI(HWND hWnd)
{
	iDepth--;
	if (iDepth==0) {
		SetFocus(hWnd);
	}
}




char cpValue[256];
char *cpName;
BOOL CALLBACK GetValueDlgProc (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam);

void GetValue(CDXScreen * Screen, HWND hWnd, HINSTANCE hInst,
			   char sName[], char sDefaultValue[],
			   char *sReturnVal) // Calls a dialog, and asks for sName
			   // sReturnVal should point to a char[256]
{

	cpName = sName;
	strcpy(cpValue, sDefaultValue);

//	Input->SetMouseLimits(0, 0, 300, 300);
	EnterGDI(Screen);
	int res = DialogBox (hInst, MAKEINTRESOURCE (IDD_PROMPT), hWnd, (DLGPROC)GetValueDlgProc);
	ExitGDI(hWnd);

	strcpy(sReturnVal, cpValue);
}


BOOL CALLBACK GetValueDlgProc (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch (iMsg) {
		case WM_INITDIALOG:
			// Set Data to what was passed tp GetValue
			SetDlgItemText(hDlg, IDC_VALUE, cpValue);
			SetDlgItemText(hDlg, IDC_NAME, cpName);
			SetFocus(GetDlgItem(hDlg, IDC_VALUE));
			break;

		case WM_COMMAND:

			switch (LOWORD (wParam))
			{
				case IDOK: // Syncronize Data
					GetDlgItemText(hDlg, IDC_VALUE, cpValue, 256);
					EndDialog(hDlg, LOWORD (wParam));
					return TRUE;
			}
			break;

	}
	return DefWindowProc(hDlg, iMsg, wParam, lParam);
}


