// TicTacToe.cpp: implementation of the CTicTacToe class.
// Author : Jimb Esser (wasteland@writeme.com)
// Date : 1-28-1
// Version : 1.0
//
//////////////////////////////////////////////////////////////////////

#include "TicTacToe.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTicTacToe::CTicTacToe()
{
	for (int x=0; x<3; x++) {
		for (int y=0; y<3; y++) {
			m_board[x][y]=0;
		}
	}
	m_iWinner=-1;
}

CTicTacToe::~CTicTacToe()
{

}

int CTicTacToe::getWinner()
{
	if (m_iWinner!=-1) { // set to -1 when it needs to be recalced
		return m_iWinner;
	} else {
		// check for a winner
		int x, y, prod, runningprod=1;
		for (x=0; x<8; x++) {
			if (x<3) {
				prod = m_board[x][0] * m_board[x][1] * m_board[x][2];
			} else if (x<6) {
				y = x - 3;
				prod = m_board[0][y] * m_board[1][y] * m_board[2][y];
			} else if (x==6) {
				prod = m_board[0][0] * m_board[1][1] * m_board[2][2];
			} else if (x==7) {
				prod = m_board[2][0] * m_board[1][1] * m_board[0][2];
			}
			runningprod*=prod;
			if (prod==8) {
				return m_iWinner = 2;
			} else if (prod == 1) {
				return m_iWinner = 1;
			}
		}
		if (runningprod!=0) {
			return m_iWinner = 3;
		}
		return m_iWinner = 0;
	}
}

void CTicTacToe::mark(int x, int y, int iPlayer)
{
	m_board[x][y] = iPlayer;
	m_iWinner = -1; // Need to recalc;
}

int CTicTacToe::getMark(int x, int y)
{
	return m_board[x][y];
}

bool CTicTacToe::isEmpty(int x, int y)
{
	return m_board[x][y]==0;
}
